/** Basic functionality we need promises to implement. @ignore internal use. */
export interface Promisy<PromiseType> {
    then(resolved: (result?: any) => any, rejected?: (err?: any) => any): PromiseType;
}
/** Promise class shim with basic functionality. @ignore internal use. */
export interface PromisyClass<PromiseType> {
    new (handler: any): PromiseType;
}
/** Task wraps a promise, delaying it until some resource gets less busy. */
export declare class Task<PromiseType extends Promisy<PromiseType>> {
    constructor(func: () => PromiseType);
    /** Wrap task result in a new promise so it can be resolved later. */
    delay(Promise: PromisyClass<PromiseType>): PromiseType;
    /** Start the task and call onFinish when done. */
    resume(onFinish: () => void): PromiseType;
    private func;
    private promise;
    private resolve;
    private reject;
}
