// This file is part of cwait, copyright (c) 2015-2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
/** Task wraps a promise, delaying it until some resource gets less busy. */
var Task = (function () {
    function Task(func) {
        this.func = func;
    }
    /** Wrap task result in a new promise so it can be resolved later. */
    Task.prototype.delay = function (Promise) {
        var _this = this;
        if (!this.promise) {
            this.promise = new Promise(function (resolve, reject) {
                _this.resolve = resolve;
                _this.reject = reject;
            });
        }
        return (this.promise);
    };
    /** Start the task and call onFinish when done. */
    Task.prototype.resume = function (onFinish) {
        var result = this.func();
        result.then(onFinish, onFinish);
        if (this.resolve)
            result.then(this.resolve, this.reject);
        return (result);
    };
    return Task;
}());
exports.Task = Task;
