import { Promisy, PromisyClass } from './Task';
export declare class TaskQueue<PromiseType extends Promisy<PromiseType>> {
    constructor(Promise: PromisyClass<PromiseType>, concurrency: number);
    /** Add a new task to the queue.
      * It will start when the number of other concurrent tasks is low enough. */
    add(func: () => PromiseType): PromiseType;
    /** Wrap a function returning a promise, so that before running
      * it waits until concurrent invocations are below this queue's limit. */
    wrap(func: (...args: any[]) => PromiseType, thisObject?: any): (...args: any[]) => PromiseType;
    /** Start the next task from the backlog. */
    private next();
    private nextBound;
    private Promise;
    /** Number of promises allowed to resolve concurrently. */
    concurrency: number;
    private backlog;
    private busyCount;
}
